<?php

declare(strict_types=1);

namespace Dedi\SyliusBlogPlugin\Repository;

use Dedi\SyliusBlogPlugin\Domain\Blog\Adapter\CategoryRepositoryInterface;
use Sylius\Component\Core\Model\ChannelInterface;

class CategoryRepository extends AbstractRepository implements CategoryRepositoryInterface
{
    public function findByNamePart(string $phrase): array
    {
        return $this->createTranslationBasedQueryBuilder()
            ->andWhere('translation.name LIKE :name')
            ->setParameter('name', '%' . $phrase . '%')
            ->getQuery()
            ->getResult()
        ;
    }

    public function findByChannel(ChannelInterface $channel, ?string $locale = null): array
    {
        return $this->createBaseQueryBuilder($channel, $locale)
            ->addOrderBy('translation.name', 'ASC')
            ->getQuery()
            ->getResult()
        ;
    }
}
